unit formatVista;

interface

const
  LargeurMax = 258;

type

  LigneComp = array[0..65000] of byte;
  UneLigne = array[0..LargeurMax-1] of word;
  UneDalle = array[0..LargeurMax-1] of UneLigne;

var
  LaDalle : UneDalle;

function Repetitions(Source : LigneComp; var Destination : LigneComp;  Longueur : integer ): integer;

function Delta(Source : LigneComp; var Destination : UneLigne; Longueur : integer ) : integer;

procedure SauveDalle(Fichier : string);

implementation

uses

  Dialogs, SysUtils;

procedure SauveDalle(Fichier : string);
var
  F : textFile;
  I, J : integer;
begin
  AssignFile(F,Fichier);
  rewrite(F);
  for I:=0 to 256 do
  begin
    for J:=0 to 256 do
      write(F,Format('%d ',[LaDalle[I][J]]));
    writeln(F);
  end;
  CloseFile(F);
end;

function Repetitions(Source : LigneComp; var Destination : LigneComp;  Longueur : integer ): integer;
var
  Indice_Source, Indice_Destination, I : integer;
  B : byte;
begin
  Indice_Source:=0;
  Indice_Destination:=0;
  repeat
    B:=Source[Indice_Source];
    inc(Indice_Source);
    dec(Longueur);
    if b>=128 then
    begin  // rptition
      for I:=0 to 256-b do
      begin
        Destination[Indice_Destination]:=Source[Indice_Source];
        inc(Indice_Destination);
      end;
      inc(Indice_Source);
      dec(Longueur);
    end
    else begin // avance normale
      for I:=0 to b do
      begin
        Destination[Indice_Destination]:=Source[Indice_Source];
        inc(Indice_Destination);
        inc(Indice_Source);
      end;
      dec(Longueur,b+1);
    end;
  until Longueur<=0;
  result:=Indice_Destination;
end;


function Delta(Source : LigneComp; var Destination : UneLigne; Longueur : integer ) : integer;
var
  Indice_Source, Indice_Destination, Altitude : integer;
  B : byte;
begin
  Altitude:=Source[0]*256+Source[1];
  Indice_Source:=2;
  Indice_Destination:=0;
  Destination[0]:=Altitude;
  while Indice_Source<Longueur do
  begin
    B:=Source[Indice_Source];
    inc(Indice_Destination);
    inc(Indice_Source);
    if B=128 then
    begin // altitude absolue
      Altitude:=Source[Indice_Source]*256;
      inc(Indice_Source);
      inc(Altitude,Source[Indice_Source]);
      inc(Indice_Source);
    end
    else // altitude relative (augmente si B<128, diminue si B>128)
      Altitude:=Altitude+ShortInt(B);
    Destination[Indice_Destination]:=Altitude;
  end;
  result:=Indice_Destination+1;
end;

end.
